AppStore rejection for directing users to Safari

Originator:ScottBossak
Number:rdar://19944416 Date Originated:2015-2-24
Status:Open Resolved:
Product:iTunes Connect Product Version:
Classification: Reproducible:
 
Our [APP] iOS app (APP_ID) was rejected for violating 10.6 in the AppStore guidelines:

----
We noticed an issue in your app that contributes to a lower quality user experience than Apple users expect. Specifically, 

- Upon launching the app, a web page in mobile Safari opens for logging in to google plus, then returns the user to the app. The user should be able to log in without opening Safari first. 
----

This is the expected user flow for a user attempting to log in with Google Plus.  If the user does not have the Google Plus app installed on their device they must sign in to their Google account (in Safari) to authenticate with Google and accept the permissions.  Once complete the user is returned to the [APP] app with a token that allows us to create an account.

We think that this is a better user experience than asking users to re-enter their Google credentials in an in-app-browser when they might already be logged in to their Google account in Safari. Any usability issues is outweighed by only having to enter your credentials once for single sign on.

Other services that provide authentication (most notably, Facebook) redirect users to Safari if their app is not installed.

Comments

The new Google Sign In iOS SDK avoids flipping to Safari by supporting fallback to WebView instead: https://developers.google.com/identity/sign-in/ios

Does current Google+ iOS SDK have the same feature?

By burak.tutanlar at Oct. 31, 2015, 5:42 p.m. (reply...)

It doesn't matter to Apple under what circumstances you arrive at the Google Plus login: immediately, later, or by what kind of button. It's the fact that it does the login in a browser outside of the app.

For a decent workaround, see Peter Lapisu's post here http://stackoverflow.com/questions/15281386/google-iphone-api-sign-in-and-share-without-leaving-app/24577040#24577040

By michael.yost at Feb. 26, 2015, 7:40 p.m. (reply...)

I've experienced the same issue when updating an app of our customer. The reason is: "The app opens a web page in mobile Safari for logging in, then returns the user to the app. The user should be able log in without opening Safari first."

By santinelli at Feb. 26, 2015, 8:31 a.m. (reply...)

One uptate to our app was rejected because of the same reason, though it was originally accepted with an external safari login. Our login is started only after the user taps on a Google+ Login button and now we have to open an internal browser.

By rodolfocartas at Feb. 25, 2015, 4:08 p.m. (reply...)

I think the problem is that, when I open your app, I am IMMEDIATELY redirected to Safari and asked to sign in to Google. I think they are suggesting that, if I'm not logged in, you show me a button that says "Sign in with Google" and, when I tap that button, you switch to Safari. Otherwise I might not realize it was your app that sent me to Safari, I might think that iOS is broken and launching the wrong app.

I'm not a mind reader but I think that's what the reviewer was thinking.

I'm not the OP, but in my case we had a big "G+" button. Only upon pressing it was a user redirected to Safari. We were rejected with similar reply.


Please note: Reports posted here will not necessarily be seen by Apple. All problems should be submitted at bugreport.apple.com before they are posted here. Please only post information for Radars that you have filed yourself, and please do not include Apple confidential information in your posts. Thank you!